﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices.ComTypes;
using System.Runtime.InteropServices;

namespace LabsB.Controls
{
	public partial class WebOffice : UserControl,UnsafeNativeMethods.IOleInPlaceFrame,NativeMethods.IOleCommandTarget
	{
		private FramerDoc framerdoc = null;
		public WebOffice()
		{
			InitializeComponent();
		}

		public Panel DocPanel
		{
			get { return this.DocPanel; }
		}

		protected override void OnHandleCreated(EventArgs e)
		{
			base.OnHandleCreated(e);
			framerdoc = new FramerDoc(this);
			framerdoc.OpenFromFile(@"D:\Work\告别中国黑客的激情年代.docx");
		}

		#region IOleInPlaceFrame
	
		IntPtr UnsafeNativeMethods.IOleInPlaceFrame.GetWindow()
		{
			return this.Handle;
		}

		int UnsafeNativeMethods.IOleInPlaceFrame.ContextSensitiveHelp(int fEnterMode)
		{
			return NativeMethods.E_NOTIMPL;
		}

		int UnsafeNativeMethods.IOleInPlaceFrame.GetBorder(NativeMethods.COMRECT lprectBorder)
		{
			return NativeMethods.S_OK;
		}

		int UnsafeNativeMethods.IOleInPlaceFrame.RequestBorderSpace(NativeMethods.COMRECT pborderwidths)
		{
			return NativeMethods.INPLACE_E_NOTOOLSPACE;
		}

		int UnsafeNativeMethods.IOleInPlaceFrame.SetBorderSpace(NativeMethods.COMRECT pborderwidths)
		{
			return NativeMethods.S_OK;
		}

		int UnsafeNativeMethods.IOleInPlaceFrame.SetActiveObject(UnsafeNativeMethods.IOleInPlaceActiveObject pActiveObject, string pszObjName)
		{
			return NativeMethods.S_OK;
		}

		int UnsafeNativeMethods.IOleInPlaceFrame.InsertMenus(IntPtr hmenuShared, NativeMethods.tagOleMenuGroupWidths lpMenuWidths)
		{
			return NativeMethods.S_OK;
		}

		int UnsafeNativeMethods.IOleInPlaceFrame.SetMenu(IntPtr hmenuShared, IntPtr holemenu, IntPtr hwndActiveObject)
		{
			return NativeMethods.S_OK;
		}

		int UnsafeNativeMethods.IOleInPlaceFrame.RemoveMenus(IntPtr hmenuShared)
		{
			return NativeMethods.S_OK;
		}

		int UnsafeNativeMethods.IOleInPlaceFrame.SetStatusText(string pszStatusText)
		{
			return NativeMethods.S_OK;
		}

		int UnsafeNativeMethods.IOleInPlaceFrame.EnableModeless(bool fEnable)
		{
			return NativeMethods.S_OK;
		}

		int UnsafeNativeMethods.IOleInPlaceFrame.TranslateAccelerator(ref NativeMethods.MSG lpmsg, short wID)
		{
			return NativeMethods.S_OK;
		}
		#endregion

		#region IOleCommandTarget

		int NativeMethods.IOleCommandTarget.QueryStatus(ref Guid pguidCmdGroup, int cCmds, NativeMethods.OLECMD prgCmds, IntPtr pCmdText)
		{
			throw new NotImplementedException();
		}

		int NativeMethods.IOleCommandTarget.Exec(ref Guid pguidCmdGroup, int nCmdID, int nCmdexecopt, object[] pvaIn, int pvaOut)
		{
			throw new NotImplementedException();
		}
		#endregion

		public class FramerDoc:
			UnsafeNativeMethods.IOleClientSite,
			IAdviseSink,
			UnsafeNativeMethods.IOleDocumentSite,
			UnsafeNativeMethods.IOleInPlaceUIWindow,
			UnsafeNativeMethods.IOleInPlaceSite
			//UnsafeNativeMethods.IContinueCallback,
			//UnsafeNativeMethods.IPreviewCallback
		{

			public WebOffice Owner
			{
				get;
				set;
			}

			private UnsafeNativeMethods.IOleObject OleObject
			{
				get { return this.pOleObject; }
				set { this.pOleObject = value; }
			}

			private UnsafeNativeMethods.IOleObject pOleObject = null;
			private Guid guid = Guid.Empty;
			private string progId = null;

			private UnsafeNativeMethods.IStorage storage = null;
			public FramerDoc(WebOffice owner)
			{
				this.Owner = owner;
			}

			public void OpenFromFile(string file)
			{
				UnsafeNativeMethods.OleInitialize();

				this.pOleObject = CreateOleObjectFromFile(file);
				if (this.OleObject != null)
				{
					this.OleObject.SetClientSite((UnsafeNativeMethods.IOleClientSite)this);
					UnsafeNativeMethods.OleRun(this.OleObject);
				}

				NativeMethods.COMRECT lprcPosRect = new NativeMethods.COMRECT(this.Owner.pnlDoc.ClientRectangle);
				if (!NativeMethods.Succeeded(this.OleObject.DoVerb(0, IntPtr.Zero, this, 0, this.Owner.pnlDoc.Handle, lprcPosRect)))
				{
					this.OleObject.DoVerb(-5, IntPtr.Zero, this, 0, this.Owner.pnlDoc.Handle, lprcPosRect);
				}

				this.Owner.pnlDoc.Invalidate();

				//OleObject.DoVerb(-5L, null, (UnsafeNativeMethods.IOleClientSite)this, -1U, Owner.Handle, null);
				//RECT rcView; GetClientRect(_hwndDoc, &rcView);
				//hr = _poleobj->DoVerb(OLEIVERB_INPLACEACTIVATE, NULL, static_cast<IOleClientSite*>(this), (UINT) - 1, _hwndDoc, &rcView);
				//if (hr == OLEOBJ_E_INVALIDVERB)
				//    hr = _poleobj->DoVerb(OLEIVERB_SHOW, NULL, static_cast<IOleClientSite*>(this), (UINT) - 1, _hwndDoc, &rcView);
			}

			private UnsafeNativeMethods.IOleObject CreateOleObjectFromFile(string fileName)
			{
				if (this.OleObject == null)
				{
					System.Guid iID_IUnknown = NativeMethods.ActiveX.IID_IUnknown;
					Guid empty = Guid.Empty;
					if (NativeMethods.Succeeded(UnsafeNativeMethods.OleCreateFromFile
						(
							ref empty, fileName, ref iID_IUnknown, NativeMethods.OLERENDER.OLERENDER_DRAW, null, null, this.CreateStorage(System.Guid.Empty), out this.pOleObject
						))
						&& (this.OleObject != null))
					{
						this.guid = System.Guid.Empty;
						this.progId = null;
						NativeMethods.Succeeded(this.OleObject.GetUserClassID(ref this.guid));
					}
				}
				return this.OleObject;
			}

			private UnsafeNativeMethods.IStorage CreateStorage(System.Guid initGuid)
			{
				if (this.storage == null)
				{
					UnsafeNativeMethods.ILockBytes iLockBytes = UnsafeNativeMethods.CreateILockBytesOnHGlobal(new HandleRef(this, IntPtr.Zero), true);
					this.storage = UnsafeNativeMethods.StgCreateDocfileOnILockBytes(iLockBytes, 0x1012, 0);
					if (initGuid != System.Guid.Empty)
					{
						UnsafeNativeMethods.WriteClassStg(this.storage, ref initGuid);
					}
				}
				return this.storage;
			}

			#region IOleClientSite
			int UnsafeNativeMethods.IOleClientSite.SaveObject()
			{
				return NativeMethods.S_OK;
			}

			int UnsafeNativeMethods.IOleClientSite.GetMoniker(int dwAssign, int dwWhichMoniker, out object moniker)
			{
				moniker = null;
				return NativeMethods.E_NOTIMPL;
			}

			int UnsafeNativeMethods.IOleClientSite.GetContainer(out UnsafeNativeMethods.IOleContainer container)
			{
				container = null;
				return NativeMethods.E_NOINTERFACE;
			}

			int UnsafeNativeMethods.IOleClientSite.ShowObject()
			{
				return NativeMethods.S_OK;
			}

			int UnsafeNativeMethods.IOleClientSite.OnShowWindow(int fShow)
			{
				return NativeMethods.S_OK;
			}

			int UnsafeNativeMethods.IOleClientSite.RequestNewObjectLayout()
			{
				return NativeMethods.E_NOTIMPL;
			}
			#endregion

			#region IAdviseSink

			void IAdviseSink.OnClose()
			{
				throw new NotImplementedException();
			}

			void IAdviseSink.OnDataChange(ref FORMATETC format, ref STGMEDIUM stgmedium)
			{
				throw new NotImplementedException();
			}

			void IAdviseSink.OnRename(IMoniker moniker)
			{
				throw new NotImplementedException();
			}

			void IAdviseSink.OnSave()
			{
				throw new NotImplementedException();
			}

			void IAdviseSink.OnViewChange(int aspect, int index)
			{
				throw new NotImplementedException();
			}
			#endregion

			#region IOleDocumentSite

			int UnsafeNativeMethods.IOleDocumentSite.ActivateMe(UnsafeNativeMethods.IOleDocumentView pViewToActivate)
			{
				if (pViewToActivate != null)
				{
					pViewToActivate.SetInPlaceSite((UnsafeNativeMethods.IOleInPlaceSite)this);
				}
				else
				{
					((UnsafeNativeMethods.IOleDocument)OleObject).CreateView((UnsafeNativeMethods.IOleInPlaceSite)this, null, 0,out  pViewToActivate);
				}

				throw new NotImplementedException();
			}
			#endregion

			#region IOleInPlaceUIWindow

			#region IOleWindow

			IntPtr UnsafeNativeMethods.IOleInPlaceUIWindow.GetWindow()
			{
				return this.Owner.pnlDoc.Handle;
			}

			int UnsafeNativeMethods.IOleInPlaceUIWindow.ContextSensitiveHelp(int fEnterMode)
			{
				return NativeMethods.E_NOTIMPL;
			}
			#endregion

			int UnsafeNativeMethods.IOleInPlaceUIWindow.GetBorder(NativeMethods.COMRECT lprectBorder)
			{
				return NativeMethods.S_OK;
			}

			int UnsafeNativeMethods.IOleInPlaceUIWindow.RequestBorderSpace(NativeMethods.COMRECT pborderwidths)
			{
				return NativeMethods.S_OK;
			}

			int UnsafeNativeMethods.IOleInPlaceUIWindow.SetBorderSpace(NativeMethods.COMRECT pborderwidths)
			{
				return NativeMethods.S_OK;
			}

			void UnsafeNativeMethods.IOleInPlaceUIWindow.SetActiveObject(UnsafeNativeMethods.IOleInPlaceActiveObject pActiveObject, string pszObjName)
			{
			}
			#endregion

			#region IOleInPlaceSite

			IntPtr UnsafeNativeMethods.IOleInPlaceSite.GetWindow()
			{
				return this.Owner.pnlDoc.Handle;
			}

			int UnsafeNativeMethods.IOleInPlaceSite.ContextSensitiveHelp(int fEnterMode)
			{
				throw new NotImplementedException();
			}

			int UnsafeNativeMethods.IOleInPlaceSite.CanInPlaceActivate()
			{
				return NativeMethods.S_OK;
			}

			int UnsafeNativeMethods.IOleInPlaceSite.OnInPlaceActivate()
			{
				return NativeMethods.S_OK;
			}

			int UnsafeNativeMethods.IOleInPlaceSite.OnUIActivate()
			{
				return NativeMethods.S_OK;
			}

			int UnsafeNativeMethods.IOleInPlaceSite.GetWindowContext(out UnsafeNativeMethods.IOleInPlaceFrame ppFrame, out UnsafeNativeMethods.IOleInPlaceUIWindow ppDoc, NativeMethods.COMRECT lprcPosRect, NativeMethods.COMRECT lprcClipRect, NativeMethods.tagOIFI lpFrameInfo)
			{
				ppDoc = (UnsafeNativeMethods.IOleInPlaceUIWindow)this;
				ppFrame = (UnsafeNativeMethods.IOleInPlaceFrame)this.Owner;
				if (lprcPosRect != null)
				{
					lprcPosRect = new NativeMethods.COMRECT(this.Owner.pnlDoc.ClientRectangle);
					if (lprcClipRect != null)
					{
						lprcClipRect = lprcPosRect;
					}
				}

				return NativeMethods.S_OK;
			}

			int UnsafeNativeMethods.IOleInPlaceSite.Scroll(NativeMethods.tagSIZE scrollExtant)
			{
				return NativeMethods.E_NOTIMPL;
			}

			int UnsafeNativeMethods.IOleInPlaceSite.OnUIDeactivate(int fUndoable)
			{
				return NativeMethods.S_OK;
			}

			int UnsafeNativeMethods.IOleInPlaceSite.OnInPlaceDeactivate()
			{
				return NativeMethods.S_OK;
			}

			int UnsafeNativeMethods.IOleInPlaceSite.DiscardUndoState()
			{
				return NativeMethods.S_OK;
			}

			int UnsafeNativeMethods.IOleInPlaceSite.DeactivateAndUndo()
			{
				return NativeMethods.S_OK;
			}

			int UnsafeNativeMethods.IOleInPlaceSite.OnPosRectChange(NativeMethods.COMRECT lprcPosRect)
			{
				return NativeMethods.E_NOTIMPL;
			}
			#endregion
		}
	}
}
