﻿namespace LabsB.Controls.Design
{
    using System;
    using System.ComponentModel;
    using System.ComponentModel.Design;
    using System.Drawing.Design;
    using System.Runtime.Serialization;
    using System.Windows.Forms;
	using System.Windows.Forms.Design;

    [Serializable]
    public class ActiveDocumentHostToolboxItem : ToolboxItem
    {
        public ActiveDocumentHostToolboxItem() : base(typeof(ActiveDocumentHost))
        {
        }

        private ActiveDocumentHostToolboxItem(SerializationInfo info, StreamingContext context)
        {
            this.Deserialize(info, context);
        }

        protected override IComponent[] CreateComponentsCore(IDesignerHost host)
        {
			IComponent[] array = base.CreateComponentsCore(host);
			if (array != null && array.Length > 0 && array[0] is ActiveDocumentHost)
			{
				IUIService iUIService = (host == null) ? null : ((IUIService)host.GetService(typeof(IUIService)));
				if (iUIService != null)
				{
					/*
					InsertableObjectPicker insertableObjectPicker = new InsertableObjectPicker();
					while (iUIService.ShowDialog(insertableObjectPicker) == DialogResult.OK)
					{
						try
						{
							if (insertableObjectPicker.FileSelected)
							{
								((ActiveDocumentHost)array[0]).SourceDocument = insertableObjectPicker.FileName;
							}
							else
							{
								((ActiveDocumentHost)array[0]).DocumentClassName = insertableObjectPicker.ProgId;
							}
						}
						catch (Exception ex)
						{
							iUIService.ShowError(ex);
							continue;
						}
						break;
					}*/
				}
			}
			return array;
        }
    }
}

