﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;

namespace LabsB.Controls
{
	public static class FormShim
	{
		private static readonly MethodInfo GetMdiClientMethodInfo;
		//GetMdiClient
		static FormShim()
		{
			Type controlType = typeof(global::System.Windows.Forms.Control);

			FormShim.GetMdiClientMethodInfo = controlType.GetMethod("GetMdiClient",
				BindingFlags.Instance | BindingFlags.NonPublic, null, new Type[] { typeof(bool) }, null);
		}

		public static System.Windows.Forms.MdiClient GetMdiClient(System.Windows.Forms.Form f) 
		{
			foreach (System.Windows.Forms.Control c in f.Controls)
			{
				if (c is System.Windows.Forms.MdiClient)
					return (System.Windows.Forms.MdiClient)c;
			}
			return null; 
		}
	}
}
